<template>
  <v-card
    outlined
    class="mb-2"
  >
    <v-card-title class="primary">
      <v-icon
        v-if="icon"
        large
        left
        class="white--text mr-3"
        v-text="icon"
      />

      <span
        class="title font-weight-light white--text"
        v-text="title"
      ></span>
    </v-card-title>

    <v-divider />

    <v-form @submit.prevent="handleSearch">
      <v-container
        class="d-flex"
        fluid
      >
        <div
          v-for="(_, index) in filterCountData"
          :key="index"
          class="d-flex"
        >
          <div class="mr-2">
            <v-text-field
              v-model="params.q[index]"
              solo
              dense
              prepend-inner-icon="mdi-magnify"
              label="Search"
              clearable
              hide-details
              autocomplete="off"
            />
          </div>

          <div
            style="width: 200px"
            class="mr-2"
          >
            <v-select
              v-model="params.filterBy[index]"
              autocomplete="off"
              clearable
              :items="filterBy"
              item-text="text"
              item-value="value"
              label="Search Filter"
              hide-details
              dense
              solo
            />
          </div>

          <div
            v-if="!hideStatus"
            style="width: 200px"
            class="mr-2"
          >
            <v-select
              v-model="params.dataStatus"
              autocomplete="off"
              :items="dataStatus"
              label="Search Filter"

              hide-details
              dense
              solo
              @change="handleSearch"
            />
          </div>
        </div>

        <div class="mr-2 d-flex align-center">
          <base-tooltip-btn
            tooltip="Search"
            class="mr-1"
            icon
            small
            type="submit"
          >
            <v-icon small>
              mdi-magnify
            </v-icon>
          </base-tooltip-btn>

          <base-tooltip-btn
            tooltip="Reset"
            class="mr-1"
            icon
            small
            @click="handleClearSearch"
          >
            <v-icon small>
              mdi-magnify-minus-outline
            </v-icon>
          </base-tooltip-btn>

          <base-tooltip-btn
            tooltip="Reload"
            class="mr-1"
            icon
            small
            @click="handleRefresh"
          >
            <v-icon small>
              mdi-reload
            </v-icon>
          </base-tooltip-btn>
          <!--
          <base-tooltip-btn
            tooltip="Add Filter"
            class="mr-1"
            icon
            small
            @click="handleRefresh"
          >
            <v-icon small>
              mdi-plus
            </v-icon>
          </base-tooltip-btn>

          <base-tooltip-btn
            v-if="showAddFilter"
            tooltip="Remove Filters"
            class="mr-1"
            icon
            small
            @click="filterCountData = 1"
          >
            <v-icon small>
              mdi-close
            </v-icon>
          </base-tooltip-btn> -->
        </div>

        <div class="d-flex flex-wrap">
          <slot name="body"></slot>
        </div>
      </v-container>
    </v-form>
  </v-card>
</template>

<script>

export default {
  name: 'BaseSearchbar',

  props: {
    filterBy: {
      type: Array,
      default: () => ([])
    },

    filterCount: {
      type: Number,
      default: 1
    },

    showAddFilter: {
      type: Boolean,
      default: false
    },

    icon: {
      type: String,
      default: ''
    },

    title: {
      type: String,
      required: true,
      default: ''
    },

    hideStatus: {
      type: [Boolean, Number],
      default: false
    },

    defaultParams: {
      type: Object,
      default: () => ({
        rows: 50,
        page: 1,
        filterBy: [],
        q: []
      })
    },

    dataStatus: {
      type: Array,
      default: () => (['Normal', 'Deleted'])
    }
  },

  data () {
    return {
      filterCountData: this.filterCount,
      params: {
        rows: this.defaultParams.rows || this.$route.query.rows,
        page: this.defaultParams.page || this.$route.query.page,
        filterBy: this.defaultParams.filterBy || this.$route.query.filterBy,
        q: this.defaultParams.q || this.$route.query.q,
        dataStatus: this.$route.query.dataStatus || this.dataStatus[0]
      }
    }
  },

  methods: {
    incrementFilterCount () {
      if (this.filterCountData < this.filterBy.length) {
        this.filterCountData++
      }
    },

    handleSearch () {
      const params = this.params
      params.filterBy = params.filterBy.filter(Boolean)
      params.q = params.q.filter(Boolean)

      this.$emit('trigger', params)
    },

    handleClearSearch () {
      const params = this.params
      params.dataStatus = this.dataStatus[0]
      for (let i = 0; i < params.q.length; i++) {
        params.q[i] = null
        params.filterBy[i] = null
      }

      this.$router.push({ query: {} })
      this.params.__ob__.dep.notify()
    },

    handleRefresh () {
      this.$emit('refresh', this.params)
    },

    test (aa) {
      console.log(aa)
    }
  }
}
</script>
